<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\CalendarioService;
use FM\Traits\TResponse;

class CalendarioController extends FMCrud {

  use TResponse;

  protected $CalendarioService;

  public function __construct($crudService, $environment, CalendarioService $CalendarioService) {
        parent::__construct($crudService, $environment);
        $this->CalendarioService = $CalendarioService;
  }

    public function getTarefasCalendario(Request $request, Response $response) {
        try {
                $data = $this->CalendarioService->getTarefasCalendario($request->getParameters());
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function getLocaisCalendario(Request $request, Response $response) {
        try {
                $data = $this->CalendarioService->getLocaisCalendario($request->getParameters());
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function getSetoresCalendario(Request $request, Response $response) {
        try {
                $data = $this->CalendarioService->getSetoresCalendario();
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function getAtividadesCalendario(Request $request, Response $response) {
        try {
                $data = $this->CalendarioService->getAtividadesCalendario();
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function getTipoDeLocal(Request $request, Response $response) {
        try {
                $data = $this->CalendarioService->getTipoDeLocal();
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }
    
}
?>