<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\Fm00011000AnaliseNaoConformidadesService;
use FM\Traits\TResponse;

class Fm00011000AnaliseNaoConformidadesController extends FMCrud {

  use TResponse;
  protected $AnaliseNaoConformidadeService;
  
  public function __construct($crudService, $environment, Fm00011000AnaliseNaoConformidadesService $AnaliseNaoConformidadeService) {
    parent::__construct($crudService, $environment);
    $this->AnaliseNaoConformidadeService = $AnaliseNaoConformidadeService;
  }

  public function getNaoConformidadesGerais(Request $request, Response $response) {
    try {
            $data = $this->AnaliseNaoConformidadeService->getNaoConformidadesGerais();
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
  } 

  public function getPrincipaisNaoConformidades(Request $request, Response $response) {
    try {
            $data = $this->AnaliseNaoConformidadeService->getPrincipaisNaoConformidades();
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
  } 
  
  public function getCriterioNaoConformidade(DTO\Request $request, DTO\Response $response) {
    $param = $request->getParameters();
    $variavel = $this->AnaliseNaoConformidadeService->getCriterioNaoConformidade($param);
    $dtsVal = new DataSet('criteriosConformidade', $variavel);
    $response->addDataSet($dtsVal);
  }

}