<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;   


class TarefaRecorrenteFactory {
    
    use TQuery;
    
    protected $connection;
    private $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }
    
    public function tarefaRecorrente($param){
        $sql="INSERT INTO FCM_TAREFARECORRENTE (NRTAREFARECORRENTE, NMTAREFA, TPLOCALTAREFA, LOCALTAREFA, NRCHECKLIST, ITENSCHECKLIST, ESCOPOSTAREFA,
                                                ITENSTAREFA, CRITERIOS, DIASSEMANA, HORARIO, DURACAO, NRFUNCTAREFA, NRFUNCVISTORIA, IDCRIARVISTORIA, NRORG, IDATIVO, DTINCLUSAO)
                   VALUES (:NRTAREFARECORRENTE, :NMTAREFA, :TPLOCALTAREFA, :LOCALTAREFA, :NRCHECKLIST, :ITENSCHECKLIST, :ESCOPOSTAREFA, :ITENSTAREFA,
                            :CRITERIOS, :DIASSEMANA, :HORARIO, :DURACAO, :NRFUNCTAREFA, :NRFUNCVISTORIA, :IDCRIARVISTORIA, :NRORG, :IDATIVO, SYSDATE)";
    
        
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
    
    public function getTarefaRecorrente(){
        $sql="SELECT NRTAREFARECORRENTE, NMTAREFA, TPLOCALTAREFA, LOCALTAREFA, NRCHECKLIST, ITENSCHECKLIST, ESCOPOSTAREFA,
                     ITENSTAREFA, CRITERIOS, DIASSEMANA, HORARIO, DURACAO, NRFUNCTAREFA, NRFUNCVISTORIA, IDCRIARVISTORIA, NRORG, IDATIVO
                FROM FCM_TAREFARECORRENTE";
    
        // $std = $this->connection->prepare($sql);
        // $std->execute();
        // return $std->fetchAll();
    }
    
    public function getDadosTarefaRecorrente($filter) {

        $sql="SELECT FCM_TAREFARECORRENTE.NRTAREFARECORRENTE, FCM_TAREFARECORRENTE.NMTAREFA, FCM_TAREFARECORRENTE.DSLOGGERACAO,FCM_TAREFARECORRENTE.IDCRIARVISTORIA,
                    FCM_TAREFARECORRENTE.LOCALTAREFA, FCM_LOCALCLI.NMLOCALCLIENTE, FCM_TAREFARECORRENTE.DIASSEMANA, FCM_TAREFARECORRENTE.HORARIO, FCM_TAREFARECORRENTE.DURACAO,
                    TO_CHAR(FCM_TAREFARECORRENTE.DTHORAREINICIAR, 'MM/DD/YYYY') AS DTHORAREINICIAR, FCM_TAREFARECORRENTE.NRCHECKLIST, FCM_TAREFARECORRENTE.ITENSCHECKLIST,
                    FCM_TAREFARECORRENTE.ITENSTAREFA, FCM_TAREFARECORRENTE.CRITERIOS,
                    CASE FCM_TAREFARECORRENTE.IDSITUACAO 
                    WHEN '1' THEN 'Em Andamento'
                    WHEN '2' THEN 'Pausada'
                    WHEN '3' THEN 'Cancelada'
                    WHEN '4' THEN 'Erro na Geração' END AS NMIDSITUACAO, FCM_TAREFARECORRENTE.IDSITUACAO,
                    FCM_TAREFARECORRENTE.CDOPERTAREFA, FUNCTAREFA.NMOPERADOR,
                    FCM_TAREFARECORRENTE.CDOPERVISTORIA, FUNCVISTORIA.NMOPERADOR AS SUPERVISOR
            FROM FCM_TAREFARECORRENTE
            LEFT JOIN OPERADOR FUNCTAREFA
                ON FCM_TAREFARECORRENTE.CDOPERTAREFA = FUNCTAREFA.CDOPERADOR
            LEFT JOIN OPERADOR FUNCVISTORIA
                ON FCM_TAREFARECORRENTE.CDOPERVISTORIA= FUNCVISTORIA.CDOPERADOR
            LEFT JOIN FCM_LOCALCLI
                ON FCM_TAREFARECORRENTE.LOCALTAREFA = FCM_LOCALCLI.NRLOCALCLIENTE
            LEFT JOIN FCM_TIPOLOCALCLI
                ON FCM_LOCALCLI.NRTIPOLOCALCLI = FCM_TIPOLOCALCLI.NRTIPOLOCALCLI
            LEFT JOIN FCM_CHECKLIST
                ON FCM_TAREFARECORRENTE.NRCHECKLIST = FCM_CHECKLIST.NRCHECKLIST ".$filter;
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    } 
    
    public function editarTarefaRecorrente($param) {

        $sql="UPDATE FCM_TAREFARECORRENTE
                 SET DIASSEMANA = :DIASSEMANA,
                     HORARIO = :HORARIO,
                     DURACAO = :DURACAO,
                     CDOPERTAREFA = :CDOPERTAREFA,
                     CDOPERVISTORIA = :CDOPERVISTORIA,
                     IDCRIARVISTORIA = :IDCRIARVISTORIA,
                     CDOPERULTATU = :CDOPERULTATU,
                     DTULTATU = SYSDATE
               WHERE NRTAREFARECORRENTE = :NRTAREFARECORRENTE";
               
        $std = $this->connection->prepare($sql);
        $std->execute($param);    
    }
    
    public function mudarStatusTarefaRecorrente($param){
        $sql="UPDATE FCM_TAREFARECORRENTE
                 SET IDSITUACAO = :IDSITUACAO,
                 DTULTATU = SYSDATE
               WHERE NRTAREFARECORRENTE = :NRTAREFARECORRENTE";
               
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
    
    public function setreinicioTarefa($param){
        $sql="UPDATE FCM_TAREFARECORRENTE
                 SET DTHORAREINICIAR = TO_DATE('".$param['DTHORAREINICIAR']."', 'YYYY/MM/DD')
               WHERE NRTAREFARECORRENTE = ".$param['NRTAREFARECORRENTE'];
        $std = $this->connection->prepare($sql);
        $std->execute();
    }

    public function getAllDatasCreate($params){
        $sql="SELECT (LISTAGG(TO_CHAR(DTHORATAREFAAGEND, 'YYYY/MM/DD'), ',')  WITHIN GROUP (ORDER BY DTHORATAREFAAGEND)) AS DTHORATAREFAAGEND
                                                                         FROM FCM_TAREFAAGEND
                                                                         WHERE NRTAREFARECORRENTE = ".$params;
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function getNameTarefas(){
        $sql="SELECT NRTAREFARECORRENTE, NMTAREFA
                FROM FCM_TAREFARECORRENTE";     
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
    
    public function deletarPeriodoTarefaRecorrente($params,$filter){
        $sql="SELECT (LISTAGG(NRCHECKLISTAGEND, ',')  WITHIN GROUP (ORDER BY NRCHECKLISTAGEND)) AS NRCHECKLISTAGEND
                                                                         FROM FCM_TAREFAAGEND
                                                                         WHERE NRTAREFARECORRENTE = ".$params." ".$filter;
        $std = $this->connection->prepare($sql);
        $std->execute();
        $RETORNO = $std->fetchAll();
        
        if($RETORNO[0]['NRCHECKLISTAGEND'] != NULL){
           $param = array(
               "NRCHECKLISTAGEND" => $RETORNO[0]['NRCHECKLISTAGEND']
            );
            
            $sql="DELETE FROM FCM_CRITERIOTARGERCHK
                         WHERE NRTAREFAGERCHK IN (SELECT NRTAREFAGERCHK
                                                    FROM FCM_TAREFAGERCHK
                                                   WHERE NRGERENCIAMENTOCHK IN (SELECT NRGERENCIAMENTOCHK
                                                                                  FROM FCM_GERENCIAMENTOCHK
                                                                                 WHERE NRCHECKLISTAGEND IN ({$param['NRCHECKLISTAGEND']})))";
            $std = $this->connection->prepare($sql);
            $std->execute();
            
            $sql="DELETE FROM FCM_TAREFAGERCHK 
                        WHERE NRGERENCIAMENTOCHK IN (SELECT NRGERENCIAMENTOCHK
                                                       FROM FCM_GERENCIAMENTOCHK
                                                      WHERE NRCHECKLISTAGEND IN ({$param['NRCHECKLISTAGEND']}))";
                      
            $std = $this->connection->prepare($sql);
            $std->execute();
            
            
            $sql="DELETE FROM FCM_CRITERIOTARAGEND
                   WHERE NRTAREFAAGEND IN (SELECT NRTAREFAAGEND
                                             FROM FCM_TAREFAAGEND 
                                            WHERE NRCHECKLISTAGEND IN ({$param['NRCHECKLISTAGEND']}))";
                      
            $std = $this->connection->prepare($sql);
            $std->execute();
            
            $sql="DELETE FROM FCM_TAREFAAGEND WHERE NRCHECKLISTAGEND IN ({$param['NRCHECKLISTAGEND']})";
                      
            $std = $this->connection->prepare($sql);
            $std->execute();
        }
    }
}

?>