<?php

namespace FM\Service;

use FM\Factory\Fm00030000TarefasRecorrentesFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use FM\Service\FuncionariosHierarqService;
use FM\Service\Fm00004000TarefasService;
use Teknisa\Libs\Util\DateUtil; 

class Fm00030000TarefasRecorrentesService {

    protected $Fm00030000TarefasRecorrentesFactory;
    protected $Environment;
    protected $newCode;
    protected $FuncionariosHierarqService;
    protected $Fm00004000TarefasService;

    public function __construct(EntityManager $entityManager, Fm00030000TarefasRecorrentesFactory $Fm00030000TarefasRecorrentesFactory, FuncionariosHierarqService $FuncionariosHierarqService, Environment $Environment, NewCode $newCode, Fm00004000TarefasService $Fm00004000TarefasService)
    {
        $this->connection                           = $entityManager->getConnection();
        $this->Fm00030000TarefasRecorrentesFactory  = $Fm00030000TarefasRecorrentesFactory;
        $this->FuncionariosHierarqService           = $FuncionariosHierarqService;
        $this->Environment                          = $Environment;
        $this->newCode                              = $newCode;
        $this->Fm00004000TarefasService             = $Fm00004000TarefasService;
        
    }

    public function getTarefasRecorrentes() {
       return $this->Fm00030000TarefasRecorrentesFactory->getDadosTarefaRecorrente();
    }

    public function insertTarefasRecorrentes($param) {
        $this->connection->beginTransaction();
        try {
            $NRORG = $this->Environment->getNrOrg();
            $operador = $this->Environment->getCdOperador();
            foreach($param['NRCRITERIOTAREFACHK'] as $key => $criterio ) {
              unset($param['NRCRITERIOTAREFACHK'][$key]['RNUM']);
              unset($param['NRCRITERIOTAREFACHK'][$key]['TOTAL_LINES']);
            }

            if($param['VISTORIA'] == '2') {
                $param['VISTORIA'] = "N";
            } else if($param['VISTORIA'] == '1') {
                $param['VISTORIA'] = "S";
            }
            foreach($param['NRSEQCONTRATO'] as $contrato){
                foreach($param['NRLOCALCLIENTE'] as $tarefa) {
                   
                    $nrTarefaRecorrente = $this->newCode->getCodeByTableName("FCM_TAREFARECORRENTE", $NRORG, 1, 10, true);
                    $parametro = array (
                        "NRTAREFARECORRENTE" => $nrTarefaRecorrente, 
                        "NMTAREFA"           => $param['NOMETAREFA'], 
                        "TPLOCALTAREFA"      => implode(",", $param['NRTIPOLOCALCLI']), 
                        "LOCALTAREFA"        => strval($tarefa), 
                        "NRCHECKLIST"        => $param['NRCHECKLIST'],
                        "ITENSCHECKLIST"     => implode(",", $param['NRATIVIDADECHK']), 
                        "ESCOPOSTAREFA"      => implode(",", $param['NRESCOPOSTAREFA']), 
                        "ITENSTAREFA"        => implode(",", $param['NRTAREFACHK']), 
                        "CRITERIOS"          => json_encode($param['NRCRITERIOTAREFACHK']), 
                        "DIASSEMANA"         => implode(",", $param['DIASEMANA']), 
                        "HORARIO"            => $param['EXECUTORHORA'][0]['HORAINICIO'], 
                        "DURACAO"            => $param['EXECUTORHORA'][0]['DURACAO'], 
                        "IDCRIARVISTORIA"    => $param['VISTORIA'], 
                        "NRORG"              => $NRORG, 
                        "IDATIVO"            => "S", 
                        "CDOPERINCLUSAO"     => $operador, 
                        "NRORGINCLUSAO"      => $NRORG,
                        "IDSITUACAO"         => "1", 
                        "CDOPERTAREFA"       => $param['EXECUTORHORA'][0]['FUNCIONARIO'], 
                        "CDOPERVISTORIA"     => $param['EXECUTORHORA'][0]['ENCARREGADO'],
                        "CDCLIENTE"          => $param['CDCLIENTE'],
                        "NRSEQCONTRATO"      => $contrato,
                    );
                
                        $this->Fm00030000TarefasRecorrentesFactory->insertTarefasRecorrentes($parametro);
                

                    if (date("m/d/Y", strtotime($param['DATERANGE'][0])) < date("m/t/Y")) {
                        $dataFinal = (date("m/d/Y", strtotime($param['DATERANGE'][0])) > date("m/25/Y")) ? date("m/t/Y", strtotime(date("m/d/Y")." +1month")) : date("m/t/Y");
                    } else if ((date("m/d/Y") > date("m/25/Y")) && date("m/d/Y", strtotime($param['DATERANGE'][0])) < date("m/t/Y", strtotime(date("m/d/Y")." +1month"))){
                    $dataFinal  = date("m/t/Y", strtotime(date("m/1/Y")." +1month"));
                    }
                    
                    if(isset($dataFinal)) {
                        $params = $param;
                        $params['NRSEQCONTRATO'] = [$contrato];
                        $params['NRLOCALCLIENTE'] = [$tarefa];
                        $params['DATERANGE'][] = $dataFinal;
                        $params['NRTAREFARECORRENTE'] = $nrTarefaRecorrente;
                        $params['VISTORIA'] = ($param['VISTORIA'] == "S") ? "1" : "2";
                    
                        $this->Fm00004000TarefasService->insertNovaTarefa($params);
                    }
                }
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function mudarStatusTarefaRecorrente($param) {
        $this->connection->beginTransaction();
        try {
           
            $paramDB = array (
                "NRTAREFARECORRENTE" => $param['NRTAREFARECORRENTE'],
                "IDSITUACAO" => NULL,
            );
            if ($param['TIPO'] == "PAUSAR") {
                $paramDB['IDSITUACAO'] = 2;
            } elseif ($param['TIPO'] == "INICIAR") {
                $paramDB['IDSITUACAO'] = 1;
            } elseif ($param['TIPO'] == "CANCELAR") {
                $paramDB['IDSITUACAO'] = 3;
            }
            
            $this->Fm00030000TarefasRecorrentesFactory->mudarStatusTarefaRecorrente($paramDB);
          
            switch ($paramDB['IDSITUACAO']) {
                case 1:
                    break;
                case 3:
                    $param["DATAFINAL"] = "";
                case 2:
                    
                    $this->deletarPeriodoTarefaRecorrente($param);
                  if($param["DATAFINAL"]) $this->dataRetorno($param);
                    break;
            }
            
            $this->connection->commit();
            $response = "OK";
        } catch (\Exception $e) {
           
             $this->connection->rollback();
             $response = "Erro".utf8_decode($e->getErrorCode());
        }
        return $response;
    }

    public function dataRetorno ($param) {
        $dataReinicio = date("d/m/Y", strtotime($param["DATAFINAL"].'+ 1 days'));
        $NR = $param["NRTAREFARECORRENTE"];
        
        $this->Fm00030000TarefasRecorrentesFactory->dataRetorno($dataReinicio, $NR);
    }

    public function inativarTarefasRecorrentes($parametros) {
        $this->connection->beginTransaction();
        try {
            $params = implode(',', $parametros["NRS"]);
            $filter = "";
            $filter .= "AND DTHORATAREFAAGEND >= TO_DATE('".$parametros['DATAINICIO']."' ,'DD/MM/YYYY')";
            
            $this->Fm00030000TarefasRecorrentesFactory->deletarPeriodoTarefaRecorrente($params, $filter);
            
            $parametro = array(
                "NRTAREFARECORRENTE" => $params,
                "IDSITUACAO"         => '3',
            );
            $this->Fm00030000TarefasRecorrentesFactory->mudarStatusTarefaRecorrente($parametro);
            
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function editarTarefaRecorrente($param) {
        $this->connection->beginTransaction();
        try {
            $params = array(
                "NRTAREFARECORRENTE"    => $param['NRTAREFARECORRENTE'],
                "DIASSEMANA"            => implode(",", $param['DIASSEMANA']),
                "HORARIO"               => $param['HORARIO'],
                "DURACAO"               => $param['DURACAO'],
                "CDOPERTAREFA"          => $param['CDOPERTAREFA'],
                "CDOPERVISTORIA"        => $param['CDOPERVISTORIA'],
                "CDOPERULTATU"          => $this->Environment->getCdOperador()
            );
            
            $this->Fm00030000TarefasRecorrentesFactory->editarTarefaRecorrente($params);
            $this->connection->commit();

        }  catch(\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function deletarPeriodoTarefaRecorrente($param) {
        $dataFinal = date("d/m/Y" , strtotime($param['DATAFINAL']));
        $filtrar = "";
        if(!$param['DATAFINAL']|| $dataFinal == NULL){
            $filtrar .= "AND DTHORATAREFAAGEND >= TO_DATE('".$param['DATAINICIAL']."' ,'DD/MM/YYYY')";
        } else {
            $filtrar .= "AND DTHORATAREFAAGEND BETWEEN TO_DATE('".$param['DATAINICIAL']."' ,'DD/MM/YYYY') AND TO_DATE('".$dataFinal."','DD/MM/YYYY')";
        }
        
        $this->Fm00030000TarefasRecorrentesFactory->deletarPeriodoTarefaRecorrente($param["NRTAREFARECORRENTE"],$filtrar);
    }

    public function recriarTarefasRecorrentes($params) {
        $NRORG = $this->Environment->getNrOrg();
        $operador = $this->Environment->getCdOperador();
        $dadosTarefasRecorrentes = $this->Fm00030000TarefasRecorrentesFactory->pegarTodosDados(strval($params['NRTAREFARECORRENTE']));
        $dataInicial = (date("m/d/Y", strtotime($params['DATAINICIAL'])) < date("m/d/Y") ? date("m/d/Y") : $params['DATAINICIAL']);
        if (date("m/d/Y", strtotime($dataInicial)) < date("m/25/Y")) {
           
            $valida = $this->Fm00030000TarefasRecorrentesFactory->validaPeriodo(strval($params['NRTAREFARECORRENTE']), date("d/m/Y", strtotime($dataInicial)));
            
            if($valida > 0){
                
                $filter = "";
                $filter .= "AND DTHORATAREFAAGEND BETWEEN '".date("d/m/Y", strtotime($dataInicial))."' AND  '".date("1/m/Y", strtotime(date("m/1/Y")." +1month"))."'";
               
                 $this->Fm00030000TarefasRecorrentesFactory->ativaTarefaRecorrente(strval($params['NRTAREFARECORRENTE']),$filter);
           } else {
            
            $criaTarefa =  array (
                "EXECUTORHORA"    => [array (
                    "FUNCIONARIO" => $dadosTarefasRecorrentes[0]['CDOPERTAREFA'], 
                    "ENCARREGADO" => $dadosTarefasRecorrentes[0]['CDOPERVISTORIA'],
                    "HORAINICIO"  => $dadosTarefasRecorrentes[0]['HORARIO'], 
                    "DURACAO"     => $dadosTarefasRecorrentes[0]['DURACAO'], 
                )],
                "NRTAREFARECORRENTE"  => strval($dadosTarefasRecorrentes[0]['NRTAREFARECORRENTE']), 
                "NOMETAREFA"          => $dadosTarefasRecorrentes[0]['NMTAREFA'], 
                "NRTIPOLOCALCLI"      => explode(",", $dadosTarefasRecorrentes[0]['TPLOCALTAREFA']), 
                "NRLOCALCLIENTE"      =>  $dadosTarefasRecorrentes[0]['LOCALTAREFA'], 
                "NRCHECKLIST"         => $dadosTarefasRecorrentes[0]['NRCHECKLIST'],
                "NRATIVIDADECHK"      => explode(",", $dadosTarefasRecorrentes[0]['ITENSCHECKLIST']), 
                "NRESCOPOSTAREFA"     => explode(",", $dadosTarefasRecorrentes[0]['ESCOPOSTAREFA']), 
                "NRTAREFACHK"         => explode(",", $dadosTarefasRecorrentes[0]['ITENSTAREFA']), 
                "NRCRITERIOTAREFACHK" => json_decode($dadosTarefasRecorrentes[0]['CRITERIOS'], true), 
                "DIASEMANA"           => explode(",", $dadosTarefasRecorrentes[0]['DIASSEMANA']), 
                "IDCRIARVISTORIA"     => $dadosTarefasRecorrentes[0]['IDCRIARVISTORIA'], 
                "NRORG"               => $NRORG, 
                "IDATIVO"             => "S", 
                "CDOPERINCLUSAO"      => $operador, 
                "NRORGINCLUSAO"       => $NRORG,
                "IDSITUACAO"          => "1", 
                "DATERANGE"           => [date("m/d/Y"), date("m/t/Y")],
                "OBSERVACOES"         => $dadosTarefasRecorrentes[0]['IDOBRIGAOBSERVACAO'],
                "VISTORIA"            => ($dadosTarefasRecorrentes[0]['IDCRIARVISTORIA'] == 'S') ? '1' : '2',
                "CDCLIENTE"           => $dadosTarefasRecorrentes[0]['CDCLIENTE'],
            );
             
            $this->Fm00004000TarefasService->insertNovaTarefa($criaTarefa);
           }
            
        } else if (date("m/d/Y", strtotime($dataInicial)) > date("m/25/Y") && date("m/d/Y", strtotime($dataInicial)) < date("m/t/Y", strtotime(date("m/1/Y")." +1month")) ){
            $dataFinal = ( $dadosTarefasRecorrentes[0]['DTHORAREINICIAR'] < date("m/t/Y", strtotime(date("m/1/Y")." +1month"))) ? $dadosTarefasRecorrentes[0]['DTHORAREINICIAR'] : date("t/m/Y", strtotime(date("m/1/Y")." +1month"));
            $valida = $this->Fm00030000TarefasRecorrentesFactory->validaPeriodo(strval($params['NRTAREFARECORRENTE']), $dataFinal);
            if($valida > 0){
                $filter = "";
                $filter .= "AND DTHORATAREFAAGEND BETWEEN '".date("d/m/Y", strtotime($dataInicial))."' AND  '".$dataFinal."'";
                 $this->Fm00030000TarefasRecorrentesFactory->ativaTarefaRecorrente(strval($params['NRTAREFARECORRENTE']),$filter);
           } else {
            $criaTarefa =  array (
                "EXECUTORHORA"    => [array (
                    "FUNCIONARIO" => $dadosTarefasRecorrentes[0]['CDOPERTAREFA'], 
                    "ENCARREGADO" => $dadosTarefasRecorrentes[0]['CDOPERVISTORIA'],
                    "HORAINICIO"  => $dadosTarefasRecorrentes[0]['HORARIO'], 
                    "DURACAO"     => $dadosTarefasRecorrentes[0]['DURACAO'], 
                )],
                "NRTAREFARECORRENTE"  => strval($dadosTarefasRecorrentes[0]['NRTAREFARECORRENTE']), 
                "NOMETAREFA"          => $dadosTarefasRecorrentes[0]['NMTAREFA'], 
                "NRTIPOLOCALCLI"      => explode(",", $dadosTarefasRecorrentes[0]['TPLOCALTAREFA']), 
                "NRLOCALCLIENTE"      =>  $dadosTarefasRecorrentes[0]['LOCALTAREFA'], 
                "NRCHECKLIST"         => $dadosTarefasRecorrentes[0]['NRCHECKLIST'],
                "NRATIVIDADECHK"      => explode(",", $dadosTarefasRecorrentes[0]['ITENSCHECKLIST']), 
                "NRESCOPOSTAREFA"     => explode(",", $dadosTarefasRecorrentes[0]['ESCOPOSTAREFA']), 
                "NRTAREFACHK"         => explode(",", $dadosTarefasRecorrentes[0]['ITENSTAREFA']), 
                "NRCRITERIOTAREFACHK" => json_decode($dadosTarefasRecorrentes[0]['CRITERIOS'], true), 
                "DIASEMANA"           => explode(",", $dadosTarefasRecorrentes[0]['DIASSEMANA']), 
                "IDCRIARVISTORIA"     => $dadosTarefasRecorrentes[0]['IDCRIARVISTORIA'], 
                "NRORG"               => $NRORG, 
                "IDATIVO"             => "S", 
                "CDOPERINCLUSAO"      => $operador, 
                "NRORGINCLUSAO"       => $NRORG,
                "IDSITUACAO"          => "1", 
                "DATERANGE"           => [date("m/d/Y"), date("m/t/Y", strtotime(date("m/1/Y")." +1month"))],
                "OBSERVACOES"         => $dadosTarefasRecorrentes[0]['IDOBRIGAOBSERVACAO'],
                "VISTORIA"            => ($dadosTarefasRecorrentes[0]['IDCRIARVISTORIA'] == 'S') ? '1' : '2',
                "CDCLIENTE"           => $dadosTarefasRecorrentes[0]['CDCLIENTE'],
            );

            $this->Fm00004000TarefasService->insertNovaTarefa($criaTarefa);
           }
        }

        $this->mudarStatusTarefaRecorrente(array(
            "TIPO"               => "INICIAR",
            "NRTAREFARECORRENTE" => $params["NRTAREFARECORRENTE"],
        ));

        $retiraReinicio = array(
            "NRTAREFARECORRENTE" =>  $params["NRTAREFARECORRENTE"],
            "DTHORAREINICIAR" => "",
        );
        $this->Fm00030000TarefasRecorrentesFactory->retirarReinicio($retiraReinicio);
    }
}
