/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MARCPROD                                                 */
/* Tabela : MARCPROD                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 03/03/2004 - Pedro Nerino Viol de Lima                                     */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
             o.name = 'DTULTATU_MARCPROD' and
             type = 'TR'                  and
             u.uid = o.uid                and
             u.name = USER)

DROP TRIGGER DTULTATU_MARCPROD
GO

CREATE TRIGGER DTULTATU_MARCPROD
ON MARCPROD
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'MARCPROD', 'CDPRODUTO=' + CDPRODUTO +
                                   ';CDMARCA='   + CDMARCA +';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE MARCPROD
      SET DTULTATUMAPR = GETDATE()
      FROM INSERTED
      WHERE ISNULL(MARCPROD.CDPRODUTO,0) = ISNULL(INSERTED.CDPRODUTO,0) and
            ISNULL(MARCPROD.CDMARCA,0)   = ISNULL(INSERTED.CDMARCA,0);
   END;
END
;
GO

